/**
 * Created by Usual on 9/24/16.
 */

var lodash = require('lodash');

var getExpList = require('../utils').getExpList;
var serverExpCode = require('../utils').serverExpCode;
var args = require('../utils').args;

var EXP_PASSWD = process.env.EXP_PASSWD;
var DELETE_FLAG = '-';

if (typeof EXP_PASSWD === 'undefined') {
    console.error('The environment variable EXP_PASSWD is expected.');
    console.error('Usage:');
    console.error('\tEXP_PASSSWD=SOME_PASSWD [EXP_HOST=CODING_OR_MART] coding-exp [args]');
    process.exit(-1);
}

var calcMaxLength = function (arr) {
    return lodash.max(lodash.map(arr, function (str) {
        return str.length;
    }));
};

var buildKey = function(key, maxLen) {
    var blanks = lodash.repeat(' ', maxLen - key.length);
    return ' * ' + key + blanks;
};

var buildValue = function (value) {
    return '[ ' + (value != 'false' ? '√' : 'x') + ' ]';
};

var outputLine = function(key, value, maxLen) {
    console.log(buildKey(key, maxLen) + '\t' + buildValue(value));
};

var output = function (exps) {
    var maxLen = calcMaxLength(Object.keys(exps));
    lodash.each(Object.keys(exps), function (key) {
        outputLine(key, exps[key], maxLen);
    });
};

var combineExp = function(exps, args) {
    lodash.each(args, function (value, key) {
        if (key.startsWith(DELETE_FLAG)) {
            key = key.substr(DELETE_FLAG.length);
            delete exps[key];
        }
        else {
            exps[key] = value;
        }
    });
    return exps;
}

getExpList(function(exps) {
    exps = combineExp(exps, args);

    output(exps);

    var expCode = serverExpCode(exps, EXP_PASSWD)

    console.log();
    console.log(expCode);
    console.log();
    console.log('add_header Set-Cookie "c=' + expCode + ';Path=/;Max-Age=259200";');
});