/**
 * Created by Usual on 8/23/16.
 */

var request = require('request');
var lodash = require('lodash');
var cookieUtils = require('cookie');

var COOKIE_NAME = 'c';

var getCookiesFromResponse = function(response) {
    return response.headers['set-cookie'];
};

var filterExpCookie = function(cookies) {
    var cookie = lodash.filter(cookies, function (cookie) {
        cookie = cookieUtils.parse(cookie);
        return typeof cookie[COOKIE_NAME] !== 'undefined';
    })[0];
    return cookieUtils.parse(cookie)[COOKIE_NAME];
};

var filterCookieHash = function(cookie) {
    return cookie.slice(0, -9);
};

var transCookieToMap = function (cookie) {
    var result = {};
    lodash.each(cookie.split(','), function (item) {
        var arr = item.split('=');
        var name = arr[0], value = arr[1];
        result[name] = value;
    });
    return result;
};

var parseCookieFromResponse = function(response) {
    return transCookieToMap(filterCookieHash(filterExpCookie(getCookiesFromResponse(response))));
};

var getExpList = function(callback) {
    request({
        url: 'https://' + (process.env.EXP_HOST || 'mart.coding.net'),
        headers: {
            'User-Agent': 'request',
        }
    }, function(error, response) {
        if (typeof callback === 'function') {
            callback(parseCookieFromResponse(response));
        } else {
            console.log(parseCookieFromResponse(response));
        }
    });
};

module.exports = getExpList;
